{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program eventbox;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

var
  foablak, vdoboz, edoboz,
  szoveg, gomb : PGtkWidget;

procedure kiiras;
begin
  if gtk_widget_visible (gomb) = true then
  begin
    gtk_label_set_text (GTK_LABEL (szoveg),
        'A gomb eltunt.');
    gtk_widget_hide (gomb);
  end else
  begin
    gtk_label_set_text (GTK_LABEL (szoveg),
        'A gomb megjelent.');
    gtk_widget_show (gomb);
  end;
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (true, 5);
  edoboz := gtk_event_box_new;
  szoveg := gtk_label_new ('Mozgasd ide az egeret!');
  gomb := gtk_button_new_with_label ('Kihasznalatlan gomb');

  gtk_window_set_title (GTK_WINDOW (foablak), 'Esemenydoboz');
  gtk_window_set_default_size (GTK_WINDOW (foablak), 250, 80);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_container_add (GTK_CONTAINER (edoboz), szoveg);
  gtk_box_pack_start (GTK_BOX (vdoboz), gomb, false, true, 0);
  gtk_box_pack_start (GTK_BOX (vdoboz), edoboz, false, true, 0);

  g_signal_connect (G_OBJECT (edoboz), 'enter_notify_event',
                    G_CALLBACK (@kiiras), NULL);

  g_signal_connect (G_OBJECT (edoboz), 'leave_notify_event',
                    G_CALLBACK (@kiiras), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
