{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program calendar;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

var
  foablak, naptar : PGtkWidget;

procedure kiir;
var
  d : integer;
begin
  d := GTK_CALENDAR (naptar)^.highlight_col;
  if d = 1 then
    writeln ('Ez egy keddi nap.');
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  naptar := gtk_calendar_new;

  gtk_window_set_title (GTK_WINDOW (foablak), 'Naptar');
  gtk_window_set_default_size (GTK_WINDOW (foablak), 200, 100);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);
  gtk_container_add (GTK_CONTAINER (foablak), naptar);

  gtk_calendar_mark_day (GTK_CALENDAR (naptar), 11);
  gtk_calendar_set_display_options (GTK_CALENDAR (naptar), 123);

  g_signal_connect (G_OBJECT (naptar), 'day_selected',
                    G_CALLBACK (@kiir), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
