{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program notebook;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

var
  foablak, fules,
  vdoboz1, vdoboz2,
  static : PGtkWidget;

procedure valtas;
begin
  gtk_notebook_set_current_page (GTK_NOTEBOOK (fules), 1);
end;

procedure kiir;
begin
  writeln ('Megtortent...');
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  fules := gtk_notebook_new;
  vdoboz1 := gtk_vbox_new (false, 0);
  vdoboz2 := gtk_vbox_new (false, 0);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Fules panel');
  gtk_window_set_default_size (GTK_WINDOW (foablak), 200, 150);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);
  gtk_container_add (GTK_CONTAINER (foablak), fules);

  static := gtk_button_new_with_label ('Valtas');
  gtk_box_pack_end (GTK_BOX (vdoboz1), static, false, false, 0);
  g_signal_connect (G_OBJECT (static), 'clicked',
                    G_CALLBACK (@valtas), NULL);

  gtk_notebook_append_page (GTK_NOTEBOOK (fules),
      vdoboz1,
      gtk_label_new_with_mnemonic ('_Elso lap'));
  gtk_notebook_append_page (GTK_NOTEBOOK (fules),
      vdoboz2,
      gtk_label_new_with_mnemonic ('_Masodik lap'));

  gtk_notebook_set_tab_pos (GTK_NOTEBOOK (fules), GTK_POS_LEFT);
  gtk_notebook_popup_enable (GTK_NOTEBOOK (fules));
  gtk_notebook_set_scrollable (GTK_NOTEBOOK (fules), true);

  g_signal_connect (G_OBJECT (fules), 'move_focus_out',
                    G_CALLBACK (@kiir), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.