{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program numeric;
{$mode objfpc}{$H+}

uses
  gtk2, glib2, sysutils;

var
  foablak, vdoboz,
  be1, be2, eredmeny,
  gomb : PGtkWidget;

procedure szamol;
var
  a, b, ki : real;
begin
  try
    if (gtk_entry_get_text (GTK_ENTRY (be1)) <> '') and
       (gtk_entry_get_text (GTK_ENTRY (be2)) <> '') then
    begin
      a := strtofloat (gtk_entry_get_text (GTK_ENTRY (be1)));
      b := strtofloat (gtk_entry_get_text (GTK_ENTRY (be2)));
      ki := a + b;
      gtk_label_set_text (GTK_LABEL (eredmeny), 
                            PCHAR (floattostr (ki)));
    end else
      gtk_label_set_text (GTK_LABEL (eredmeny),
                            'Nincs mit osszeadni!');
  except
    on EConvertError do
    begin
      gtk_entry_set_text (GTK_ENTRY (be1), '');
      gtk_entry_set_text (GTK_ENTRY (be2), '');
      gtk_label_set_text (GTK_LABEL (eredmeny),
                            'Valos szamot kerek!');
    end;
  end;
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 10);
  be1 := gtk_entry_new; 
  be2 := gtk_entry_new; 
  eredmeny := gtk_label_new ('0');
  gomb := gtk_button_new_with_label ('osszead');

  gtk_window_set_title (GTK_WINDOW (foablak), 'Osszeado');
  gtk_widget_set_size_request (vdoboz, 150, 150);
  gtk_window_set_resizable (GTK_WINDOW (foablak), false);
  gtk_label_set_selectable (GTK_LABEL (eredmeny), true);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), be1, false, true, 0);
  gtk_box_pack_start (GTK_BOX (vdoboz), be2, false, true, 0);
  gtk_box_pack_start (GTK_BOX (vdoboz), eredmeny, false, true, 0);
  gtk_box_pack_end (GTK_BOX (vdoboz), gomb, false, true, 0);

  g_signal_connect_swapped (G_OBJECT (be1), 'activate',
                    G_CALLBACK (@gtk_widget_grab_focus),
                    G_OBJECT (be2));

  g_signal_connect_swapped (G_OBJECT (be2), 'activate',
                    G_CALLBACK (@gtk_widget_activate),
                    G_OBJECT (gomb));

  g_signal_connect (G_OBJECT (gomb), 'clicked',
                    G_CALLBACK (@szamol), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
