{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program ornaments;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

var
  foablak, tabla,
  static, gomb, nyil, edoboz : PGtkWidget;
  irany : byte;

procedure iranyvaltas;
begin
  case irany of
    1 :
      begin
        gtk_arrow_set (GTK_ARROW (nyil),
            GTK_ARROW_RIGHT, GTK_SHADOW_NONE);
        irany := 3;
      end;
    3 :
      begin
        gtk_arrow_set (GTK_ARROW (nyil),
            GTK_ARROW_DOWN, GTK_SHADOW_NONE);
        irany := 1;
      end;
  end;
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  tabla := gtk_table_new (3, 4, false);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Diszitesek');
  gtk_widget_set_size_request (foablak, 250, 150);
  gtk_window_set_resizable (GTK_WINDOW (foablak), false);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);

  static := gtk_frame_new (NULL);
  gomb := gtk_image_new_from_stock (GTK_STOCK_HOME, 1);
  gtk_frame_set_label_align (GTK_FRAME (static), 0.5, 0.5);
  gtk_frame_set_label_widget (GTK_FRAME (static), gomb);
  gtk_frame_set_shadow_type (GTK_FRAME (static), GTK_SHADOW_IN);
  gtk_container_add (GTK_CONTAINER (foablak), static);
  gtk_container_add (GTK_CONTAINER (static), tabla);

  static := gtk_label_new ('Jobbra mutato nyil:');
  gtk_misc_set_alignment (GTK_MISC (static), 1, 0.5);
  gtk_table_attach (GTK_TABLE (tabla), static, 0, 2, 0, 1,
                    GTK_EXPAND or GTK_FILL, GTK_FILL, 2, 2);

  edoboz := gtk_event_box_new;
  nyil := gtk_arrow_new (GTK_ARROW_RIGHT, GTK_SHADOW_NONE);
  irany := 3;
  gtk_misc_set_alignment (GTK_MISC (nyil), 0, 0.5);
  gtk_widget_set_size_request (nyil, 30, 50);
  gtk_container_add (GTK_CONTAINER (edoboz), nyil);
  gtk_table_attach (GTK_TABLE (tabla), edoboz, 2, 3, 0, 1,
                    GTK_FILL, GTK_FILL, 0, 0);
  g_signal_connect (G_OBJECT (edoboz), 'button_release_event',
                    G_CALLBACK (@iranyvaltas), NULL);

  static := gtk_hseparator_new;
  gtk_table_attach (GTK_TABLE (tabla), static, 0, 3, 1, 2,
                    GTK_EXPAND or GTK_FILL, GTK_FILL, 2, 2);
  static := gtk_label_new ('vizszintes');
  gtk_table_attach (GTK_TABLE (tabla), static, 0, 3, 2, 3,
                    GTK_FILL, GTK_FILL, 2, 2);
  static := gtk_label_new ('Valasztovonalak:');
  gtk_table_attach (GTK_TABLE (tabla), static, 0, 1, 3, 4,
                    GTK_EXPAND or GTK_FILL, GTK_FILL, 2, 2);
  static := gtk_vseparator_new;
  gtk_table_attach (GTK_TABLE (tabla), static, 1, 2, 3, 4,
                    GTK_FILL, GTK_EXPAND or GTK_FILL, 2, 5);
  static := gtk_label_new ('fuggoleges');
  gtk_table_attach (GTK_TABLE (tabla), static, 2, 3, 3, 4,
                    GTK_FILL, GTK_FILL, 2, 2);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
