{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program progressbar;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

var
  foablak, vdoboz,
  gomb, jelzes1, jelzes2 : PGtkWidget;
  x : boolean = true;
  fract : gdouble = 0;

function leptet (data:pointer) : longbool; cdecl;
begin
  if x = false then
  begin
    if fract <= 0.99 then 
      fract := fract + 0.01 else
      fract := 0;
    gtk_progress_bar_set_fraction
        (GTK_PROGRESS_BAR (jelzes1), fract);
  end;
  gtk_progress_bar_pulse (GTK_PROGRESS_BAR (jelzes2));
  leptet := true;
end;

procedure indit;
begin
  if x = true then
  begin
    gtk_progress_bar_set_pulse_step
        (GTK_PROGRESS_BAR (jelzes2), 0.01);
    x := false;
  end else
  begin
    gtk_progress_bar_set_pulse_step
        (GTK_PROGRESS_BAR (jelzes2), 0);
    x := true;
  end;
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 0);
  gomb := gtk_button_new_from_stock (GTK_STOCK_APPLY);
  jelzes1 := gtk_progress_bar_new;
  jelzes2 := gtk_progress_bar_new;

  gtk_window_set_title (GTK_WINDOW (foablak), 'Folyamatjelzo');
  gtk_window_set_default_size (GTK_WINDOW (foablak), 250, -1);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), gomb, false, false, 5);
  gtk_box_pack_end (GTK_BOX (vdoboz), jelzes2, false, false, 5);
  gtk_box_pack_end (GTK_BOX (vdoboz), jelzes1, false, false, 5);

  gtk_progress_bar_set_text
      (GTK_PROGRESS_BAR (jelzes1), 'szazalekos mod');
  gtk_progress_bar_set_text
      (GTK_PROGRESS_BAR (jelzes2), 'pulzalo mod');
  gtk_progress_bar_set_pulse_step
      (GTK_PROGRESS_BAR (jelzes2), 0);

  g_timeout_add (10, @leptet, NULL);

  g_signal_connect (G_OBJECT (gomb), 'clicked',
                    G_CALLBACK (@indit), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
