{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program rulers;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

const
  H_MERET = 400;
  V_MERET = 200;

var
  foablak,
  tabla,
  hvonalzo, vvonalzo : PGtkWidget;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  tabla := gtk_table_new (2, 2, false);
  hvonalzo := gtk_hruler_new;
  vvonalzo := gtk_vruler_new;

  gtk_window_set_title (GTK_WINDOW (foablak), 'Vonalzok');
  gtk_window_set_default_size (GTK_WINDOW (foablak),
                               H_MERET, V_MERET);
  gtk_ruler_set_metric (GTK_RULER (hvonalzo), GTK_PIXELS);
  gtk_ruler_set_range (GTK_RULER (hvonalzo), 0, H_MERET, 0, 10);
  gtk_ruler_set_metric (GTK_RULER (vvonalzo), GTK_PIXELS);
  gtk_ruler_set_range (GTK_RULER (vvonalzo), 0, V_MERET, 0, 10);

  gtk_container_add (GTK_CONTAINER (foablak), tabla);
  gtk_table_attach (GTK_TABLE (tabla), hvonalzo, 1, 2, 0, 1,
                    GTK_EXPAND or GTK_FILL, GTK_FILL, 0, 0 );
  gtk_table_attach (GTK_TABLE (tabla), vvonalzo, 0, 1, 1, 2,
                    GTK_FILL, GTK_EXPAND or GTK_FILL, 0, 0);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
