{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program spinbutton;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

var
  foablak, vdoboz,
  szoveg, gomb : PGtkWidget;
  lepeskoz : PGtkObject;

procedure kiir;
begin
  writeln (gtk_spin_button_get_value
             (GTK_SPIN_BUTTON (gomb)));
  writeln (gtk_spin_button_get_value_as_int
             (GTK_SPIN_BUTTON (gomb)));
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 0);
  szoveg := gtk_label_new
            ('Allitsd be az erteket 0 es 100 kozott:');
  lepeskoz := gtk_adjustment_new
              (1.00, 0.0, 100.0, 1.0, 10.0, 1.0);
  gomb := gtk_spin_button_new
              (GTK_ADJUSTMENT (lepeskoz),  1.0, 2);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Leptetogomb');
  gtk_window_set_resizable (GTK_WINDOW (foablak), false);
  gtk_widget_set_size_request (foablak, 300, 100);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (gomb), true);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), szoveg, false, true, 0);
  gtk_box_pack_end (GTK_BOX (vdoboz), gomb, false, true, 0);

  g_signal_connect (G_OBJECT (gomb), 'value_changed',
                    G_CALLBACK (@kiir), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
