{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program menu_radio;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

var
  foablak, vdoboz,
  menusor, nezet, nezetmenu, allapot, allapotmenu,
  radbe, radki,
  allapotsor : PGtkWidget;
  csoport : PGSList;

procedure allapotsor_atv;
begin
  if (gtk_check_menu_item_get_active
          (GTK_CHECK_MENU_ITEM (radbe))) then
    gtk_widget_show (allapotsor) else
    gtk_widget_hide (allapotsor);
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 0);
  allapotsor := gtk_statusbar_new;

  gtk_widget_set_size_request (foablak, 250, 100);
  gtk_window_set_title (GTK_WINDOW (foablak), 'Menusor');

  menusor := gtk_menu_bar_new;
  nezet := gtk_menu_item_new_with_label ('Nezet');
  nezetmenu := gtk_menu_new;
  allapot := gtk_menu_item_new_with_label ('Allapotsor');
  allapotmenu := gtk_menu_new;
  radbe := gtk_radio_menu_item_new_with_label (NULL, 'be');
  csoport := gtk_radio_menu_item_get_group
                 (GTK_RADIO_MENU_ITEM (radbe));
  radki := gtk_radio_menu_item_new_with_label (csoport, 'ki');

  gtk_menu_shell_append (GTK_MENU_SHELL (menusor), nezet);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (nezet), nezetmenu);
  gtk_menu_shell_append (GTK_MENU_SHELL (nezetmenu), allapot);
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (allapot), allapotmenu);
  gtk_menu_shell_append (GTK_MENU_SHELL (allapotmenu), radbe);
  gtk_menu_shell_append (GTK_MENU_SHELL (allapotmenu), radki);

  gtk_check_menu_item_set_active
      (GTK_CHECK_MENU_ITEM (radbe), true);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), menusor, false, false, 0);
  gtk_box_pack_end (GTK_BOX (vdoboz), allapotsor, false, false, 0);

  g_signal_connect (G_OBJECT (radbe), 'activate',
                    G_CALLBACK (@allapotsor_atv), NULL);

  g_signal_connect (G_OBJECT (radki), 'activate',
                    G_CALLBACK (@allapotsor_atv), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
