{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program treeview_simple;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

const
  NEV_OSZLOP = 0;

var
  foablak,
  vdoboz,
  treeview  : PGtkWidget;

  oszlop    : PGtkTreeViewColumn;
  renderelo : PGtkCellRenderer;
  alak      : PGtkListStore;
  ismetlo   : TGtkTreeIter;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 0);

  alak := gtk_list_store_new (1, G_TYPE_STRING);
  treeview := gtk_tree_view_new_with_model (alak);
  renderelo := gtk_cell_renderer_text_new;
  oszlop := gtk_tree_view_column_new_with_attributes
                ('Nev:', renderelo, 'text',
                  NEV_OSZLOP, NULL);
  gtk_tree_view_append_column (GTK_TREE_VIEW (treeview), oszlop);

  gtk_list_store_append (alak, @ismetlo);
  gtk_list_store_set (alak, @ismetlo,
                          NEV_OSZLOP, 'Nemoda Buda',
                          -1);
  gtk_list_store_append (alak, @ismetlo);
  gtk_list_store_set (alak, @ismetlo,
                          NEV_OSZLOP, 'Vizes K. Anna',
                          -1);
  gtk_list_store_append (alak, @ismetlo);
  gtk_list_store_set (alak, @ismetlo,
                          NEV_OSZLOP, 'Csin Csilla',
                          -1);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Listanezet');
  gtk_widget_set_size_request (foablak, 200, -1);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), treeview, false, false, 0);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.