{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program filechooser;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

var
  foablak,
  vdoboz,
  widget,
  gomb1, gomb2 : PGtkWidget;

procedure megnyitas1;
begin
  writeln (gtk_file_chooser_get_filename
               (GTK_FILE_CHOOSER (gomb1)));
end;

procedure megnyitas2;
var
  mnyablak : PGtkWidget;
  szuro1,
  szuro2   : PGtkFileFilter; 
  filenev  : PGChar;
begin
  mnyablak := gtk_file_chooser_dialog_new
                  ('Fajl megnyitasa',
                   GTK_WINDOW (foablak),
                   GTK_FILE_CHOOSER_ACTION_OPEN,
                   GTK_STOCK_OPEN, [GTK_RESPONSE_ACCEPT,
                   GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                   NULL]);
  szuro1 := gtk_file_filter_new;
  gtk_file_filter_add_pattern (szuro1, '*.txt');
  gtk_file_filter_set_name (szuro1, '.txt fajlok');
  gtk_file_chooser_add_filter
      (GTK_FILE_CHOOSER (mnyablak), szuro1);
  szuro2 := gtk_file_filter_new;
  gtk_file_filter_add_pattern (szuro2, '*');
  gtk_file_filter_set_name (szuro2, 'minden fajl');
  gtk_file_chooser_add_filter
      (GTK_FILE_CHOOSER (mnyablak), szuro2);
if (gtk_dialog_run (GTK_DIALOG (mnyablak)) =
    GTK_RESPONSE_ACCEPT) then
begin
  filenev := gtk_file_chooser_get_filename
                 (GTK_FILE_CHOOSER (mnyablak));
  writeln (filenev);
  g_free (filenev);
end;
  gtk_widget_destroy (mnyablak);
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (true, 10);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Megnyitas');
  gtk_widget_set_size_request (foablak, 300, 150);

  gtk_window_set_resizable (GTK_WINDOW (foablak), false);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);

  widget := gtk_label_new ('A ketfele megnyitasi mod:');
  gtk_container_add (GTK_CONTAINER (vdoboz), widget);

  gomb1 := gtk_file_chooser_button_new (NULL,
               GTK_FILE_CHOOSER_ACTION_OPEN);
  gtk_file_chooser_button_set_title
      (GTK_FILE_CHOOSER_BUTTON (gomb1), 'Fajl megnyitasa');
  gtk_box_pack_start (GTK_BOX (vdoboz), gomb1, false, true, 0);
  g_signal_connect (G_OBJECT (gomb1), 'selection_changed',
                    G_CALLBACK (@megnyitas1), NULL);

  gomb2 := gtk_button_new_from_stock (GTK_STOCK_OPEN);
  gtk_box_pack_start (GTK_BOX (vdoboz), gomb2, false, false, 0);
  g_signal_connect (G_OBJECT (gomb2), 'clicked',
                    G_CALLBACK (@megnyitas2), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
