{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program images;
{$mode objfpc}{$H+}

uses
  gtk2, glib2, gdk2pixbuf;

var
  foablak,
  hdoboz,
  kep    : PGtkWidget;
  pixbuf : PGdkPixbuf;
  anim   : PGdkPixbufAnimation;
  error  : PGError = NULL;

procedure megjelenit (tipus:boolean);
begin
  if error <> NULL then
  begin
    writeln (error^.message);
    kep := gtk_image_new_from_stock
               (GTK_STOCK_DIALOG_ERROR,
                GTK_ICON_SIZE_DIALOG);
  end else
  begin
    if tipus = true then
      kep := gtk_image_new_from_pixbuf (pixbuf) else
      kep := gtk_image_new_from_animation (anim);
  end;
  gtk_box_pack_start (GTK_BOX (hdoboz), kep, false, false, 0);
  error := NULL;
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  hdoboz := gtk_hbox_new (false, 5);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Kepek');
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);
  gtk_container_add (GTK_CONTAINER (foablak), hdoboz);

  kep := gtk_image_new_from_stock
             (GTK_STOCK_DIALOG_WARNING,
              GTK_ICON_SIZE_DIALOG);
  gtk_image_set_pixel_size (GTK_IMAGE (kep), 100);
  gtk_box_pack_start (GTK_BOX (hdoboz), kep, false, false, 0);

  pixbuf := gdk_pixbuf_new_from_file
                ('gart-home.png', @error);
  megjelenit (true);

  anim := gdk_pixbuf_animation_new_from_file
              ('floppybuddy.gif', @error);
  megjelenit (false);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
