{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program pixmap_xpm;
{$mode objfpc}{$H+}

uses
  gtk2, glib2, gdk2;

const
  kep_xpm : array[0..9] of PChar =
  ('5 5 4 1',
   '  c none',
   'b c black',
   'G c #007700',
   'g c #00CC00',
   '  g  ',
   ' GGG ',
   'gGbGg',
   ' GGG ',
   '  g  ');

var
  foablak,
  kep    : PGtkWidget;
  pixmap : PGdkPixmap;
  cmap   : PGdkColormap; 
  mask   : PGdkBitmap;
  style  : PGtkStyle;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  cmap := gdk_colormap_get_system;
  style := gtk_widget_get_style (foablak);

{ xpm egy fajlbol }
{ pixmap := gdk_pixmap_colormap_create_from_xpm
               (foablak^.window,
                cmap, mask, 
                @style^.bg[GTK_STATE_NORMAL],
                'kep.xpm'); }

{ xpm konstansbol }
  pixmap := gdk_pixmap_colormap_create_from_xpm_d
               (foablak^.window,
                cmap, mask, 
                @style^.bg[GTK_STATE_NORMAL],
                PPGChar (kep_xpm));

  kep := gtk_image_new_from_pixmap (pixmap, mask);

  gtk_window_set_title (GTK_WINDOW (foablak), 'XPM -> pixmap');
  gtk_window_set_default_size (GTK_WINDOW (foablak), 150, 100);
  gtk_container_add (GTK_CONTAINER (foablak), kep);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
