{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program arrows;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

var
  foablak, hdoboz,
  szoveg, nyil, edoboz : PGtkWidget;
  irany : byte;

procedure iranyvaltas;
begin
  case irany of
    0 :
      begin
        gtk_arrow_set (GTK_ARROW (nyil),
            GTK_ARROW_RIGHT, GTK_SHADOW_NONE);
        irany := 3;
      end;
    1 :
      begin
        gtk_arrow_set (GTK_ARROW (nyil),
            GTK_ARROW_LEFT, GTK_SHADOW_NONE);
        irany := 2;
      end;
    2 :
      begin
        gtk_arrow_set (GTK_ARROW (nyil),
            GTK_ARROW_UP, GTK_SHADOW_NONE);
        irany := 0;
      end;
    3 :
      begin
        gtk_arrow_set (GTK_ARROW (nyil),
            GTK_ARROW_DOWN, GTK_SHADOW_NONE);
        irany := 1;
      end;
  end;
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  hdoboz := gtk_hbox_new (false, 0);
  nyil := gtk_arrow_new (GTK_ARROW_RIGHT, GTK_SHADOW_NONE);
  edoboz := gtk_event_box_new;
  szoveg := gtk_label_new ('Kattints a nyilra!');
  irany := 3;

  gtk_window_set_title (GTK_WINDOW (foablak), 'Nyilak');
  gtk_widget_set_size_request (foablak, 150, 50);
  gtk_window_set_resizable (GTK_WINDOW (foablak), false);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);

  gtk_container_add (GTK_CONTAINER (edoboz), nyil);
  gtk_container_add (GTK_CONTAINER (foablak), hdoboz);
  gtk_box_pack_start (GTK_BOX (hdoboz), edoboz, false, false, 0);
  g_signal_connect (G_OBJECT (edoboz), 'button_press_event',
                    G_CALLBACK (@iranyvaltas), NULL);

  gtk_box_pack_start (GTK_BOX (hdoboz), szoveg, false, false, 0);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
