{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program gtkexpander;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

var
  foablak, expander,
  vdoboz1, vdoboz2,
  static : PGtkWidget;

procedure kiir;
begin
  writeln ('Megtortent...');
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  expander := gtk_expander_new ('<b>Kinyit / Becsuk</b>');
  vdoboz1 := gtk_vbox_new (false, 0);
  vdoboz2 := gtk_vbox_new (false, 0);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Expander');
  gtk_window_set_default_size (GTK_WINDOW (foablak), 200, 100);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);
  gtk_container_add (GTK_CONTAINER (foablak), vdoboz1);

  gtk_box_pack_start (GTK_BOX (vdoboz1), expander, false, false, 0);
  gtk_container_add (GTK_CONTAINER (expander), vdoboz2);

  gtk_expander_set_use_markup (GTK_EXPANDER (expander), true);

  static := gtk_label_new ('Ez egy rejtett felirat');
  gtk_box_pack_start (GTK_BOX (vdoboz2), static, false, false, 0);
  static := gtk_button_new_with_label ('Ez egy rejtett gomb');
  gtk_box_pack_start (GTK_BOX (vdoboz2), static, false, false, 0);

  g_signal_connect (G_OBJECT (expander), 'activate',
                    G_CALLBACK (@kiir), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.