{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program labels;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

var
  foablak, vdoboz,
  felirat1, felirat2, felirat3,
  gomb : PGtkWidget;

procedure use_markup;
begin
  gtk_label_set_use_markup (GTK_LABEL (felirat2), true);
  gtk_label_set_use_markup (GTK_LABEL (felirat3), true);
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 0);
  felirat1 := gtk_label_new (NULL);
  felirat2 := gtk_label_new (NULL);
  felirat3 := gtk_label_new (NULL);
  gomb := gtk_button_new_from_stock (GTK_STOCK_APPLY);

  gtk_misc_set_alignment (GTK_MISC (felirat1), 0.0, 0.5);
  gtk_label_set_markup (GTK_LABEL (felirat1),
    '<span foreground="red">Ez egy <b>piros</b> felirat</span>!');

  gtk_label_set_label (GTK_LABEL (felirat2),
    gtk_label_get_label (GTK_LABEL (felirat1)));

  gtk_label_set_label (GTK_LABEL (felirat3),
    gtk_label_get_text (GTK_LABEL (felirat1)));

  gtk_window_set_title (GTK_WINDOW (foablak),
    'Feliratok leironyelvvel');
  gtk_widget_set_size_request (foablak, 400, 150);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), felirat1, false, false, 0);
  gtk_box_pack_start (GTK_BOX (vdoboz), felirat2, false, false, 10);
  gtk_box_pack_start (GTK_BOX (vdoboz), felirat3, false, false, 0);
  gtk_box_pack_end (GTK_BOX (vdoboz), gomb, false, false, 0);

  g_signal_connect (G_OBJECT (gomb), 'clicked',
                    G_CALLBACK (@use_markup), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
