{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program panes;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

var
  foablak, hmezo, vmezo,
  hdoboz,
  keret1, keret2, keret3, keret4,
  static : PGtkWidget;

procedure kiir;
begin
  writeln ('Megtortent...');
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  hdoboz := gtk_hbox_new (false, 10);
  hmezo := gtk_hpaned_new;
  vmezo := gtk_vpaned_new;
  keret1 := gtk_frame_new (NULL);
  keret2 := gtk_frame_new (NULL);
  keret3 := gtk_frame_new (NULL);
  keret4 := gtk_frame_new (NULL);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Osztasmezo');
  gtk_window_set_resizable (GTK_WINDOW (foablak), false);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);

  gtk_frame_set_shadow_type (GTK_FRAME (keret1),
                             GTK_SHADOW_ETCHED_OUT);
  gtk_frame_set_shadow_type (GTK_FRAME (keret2),
                             GTK_SHADOW_ETCHED_OUT);

  gtk_container_add (GTK_CONTAINER (foablak), hdoboz);
  gtk_container_add (GTK_CONTAINER (hdoboz), hmezo);
  gtk_container_add (GTK_CONTAINER (hdoboz), vmezo);
  gtk_paned_pack1 (GTK_PANED (hmezo), keret1, true, true);
  gtk_paned_pack2 (GTK_PANED (hmezo), keret2, true, true);
  gtk_paned_add1 (GTK_PANED (vmezo), keret3);
  gtk_paned_add2 (GTK_PANED (vmezo), keret4);

  static := gtk_label_new ('Felirat 1');
  gtk_widget_set_size_request (static, 80, -1);
  gtk_container_add (GTK_CONTAINER (keret1), static);
  static := gtk_label_new ('Felirat 2');
  gtk_widget_set_size_request (static, 80, -1);
  gtk_container_add (GTK_CONTAINER (keret2), static);
  static := gtk_label_new ('Felirat 3');
  gtk_widget_set_size_request (static, 80, 40);
  gtk_container_add (GTK_CONTAINER (keret3), static);
  static := gtk_label_new ('Felirat 4');
  gtk_widget_set_size_request (static, 80, 40);
  gtk_container_add (GTK_CONTAINER (keret4), static);

  g_signal_connect (G_OBJECT (hmezo), 'toggle-handle-focus',
                    G_CALLBACK (@kiir), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.