{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program scales;
{$mode objfpc}{$H+}

uses
  gtk2, glib2, sysutils;

var
  foablak, hdoboz,
  hcsuszka, vcsuszka : PGtkWidget;

procedure kiir;
begin
  writeln (floattostr (gtk_range_get_value (GTK_RANGE (vcsuszka))));
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  hdoboz := gtk_hbox_new (false, 0);
  hcsuszka := gtk_hscale_new_with_range (0, 100, 0.1);
  vcsuszka := gtk_vscale_new_with_range (0, 100, 0.1);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Csuszka');
  gtk_window_set_resizable (GTK_WINDOW (foablak), false);
  gtk_widget_set_size_request (foablak, 300, 200);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);
  gtk_container_add (GTK_CONTAINER (foablak), hdoboz);
  gtk_container_add (GTK_CONTAINER (hdoboz), hcsuszka);
  gtk_container_add (GTK_CONTAINER (hdoboz), vcsuszka);

  gtk_scale_set_draw_value (GTK_SCALE (vcsuszka), true);
  gtk_scale_set_value_pos (GTK_SCALE (vcsuszka), GTK_POS_RIGHT);
  gtk_scale_set_digits (GTK_SCALE (vcsuszka), 2);

  g_signal_connect (G_OBJECT (vcsuszka), 'value_changed',
                    G_CALLBACK (@kiir), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
