{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program togglebuttons;
{$mode objfpc}{$H+}

uses
  gtk2, glib2;

var
  foablak, vdoboz,
  szoveg, gomb1, gomb2 : PGtkWidget;

procedure kiir;
begin
  if gtk_toggle_button_get_active
         (GTK_TOGGLE_BUTTON (gomb1)) or
     gtk_toggle_button_get_active
         (GTK_TOGGLE_BUTTON (gomb2)) then
  gtk_label_set_label (GTK_LABEL (szoveg),
    'Valamelyik gombot benyomtad.') else
  gtk_label_set_label (GTK_LABEL (szoveg),
    'Egyik gomb sincs benyomva.');
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 0);
  szoveg := gtk_label_new ('Kapcsolo- es valasztogomb:');
  gomb1 := gtk_toggle_button_new_with_label ('Kapcsologomb');
  gomb2 := gtk_check_button_new_with_label ('Valasztogomb');

  gtk_window_set_title (GTK_WINDOW (foablak), 'Kapcsologombok');
  gtk_window_set_resizable (GTK_WINDOW (foablak), false);
  gtk_widget_set_size_request (foablak, 250, 100);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), szoveg, false, true, 0);
  gtk_box_pack_end (GTK_BOX (vdoboz), gomb2, false, true, 0);
  gtk_box_pack_end (GTK_BOX (vdoboz), gomb1, false, true, 0);

  g_signal_connect (G_OBJECT (gomb1), 'toggled',
                    G_CALLBACK (@kiir), NULL);
  g_signal_connect (G_OBJECT (gomb2), 'toggled',
                    G_CALLBACK (@kiir), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
