{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program dialog;
{$mode objfpc}{$H+}

uses
  gtk2, gdk2, glib2;

var
  foablak, vdoboz,
  szoveg, gomb : PGtkWidget;
  
procedure dialog_mutat;
var
  dialog, tabla,
  widget : PGtkWidget;
begin
  dialog := gtk_dialog_new_with_buttons ('Dialogusablak',
             GTK_WINDOW (foablak),
             GTK_DIALOG_DESTROY_WITH_PARENT,
             GTK_STOCK_SAVE, GTK_RESPONSE_APPLY,
             GTK_STOCK_QUIT, GTK_RESPONSE_CLOSE,
             NULL);
  tabla := gtk_table_new (3, 2, true);
  gtk_window_set_position (GTK_WINDOW (dialog),
                           GTK_WIN_POS_MOUSE);
  gtk_widget_set_size_request (dialog, 350, 180);
  gtk_dialog_add_button (GTK_DIALOG (dialog), GTK_STOCK_HELP, 
             GTK_RESPONSE_HELP);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)^.vbox),
                      tabla, false, false, 0);

  widget := gtk_label_new ('Hello! Ez itt egy uzenet!');
  gtk_table_attach_defaults (GTK_TABLE (tabla), widget,
                             0, 2, 0, 1);
  widget := gtk_button_new_with_label ('elso gomb');
  gtk_table_attach (GTK_TABLE (tabla), widget, 0, 1, 1, 2,
                    GTK_FILL, GTK_FILL, 5, 5);
  widget := gtk_button_new_with_label ('masodik gomb');
  gtk_table_attach (GTK_TABLE (tabla), widget, 1, 2, 1, 2,
                    GTK_FILL, GTK_FILL, 5, 5);
  widget := gtk_label_new ('Ujabb felirat.');
  gtk_table_attach (GTK_TABLE (tabla), widget, 0, 1, 2, 3,
                    GTK_FILL, GTK_FILL, 5, 5);
  widget := gtk_button_new_with_label ('harmadik gomb');
  gtk_table_attach (GTK_TABLE (tabla), widget, 1, 2, 2, 3,
                    GTK_FILL, GTK_FILL, 5, 5);

  gtk_widget_show_all (tabla);
  if (gtk_dialog_run (GTK_DIALOG (dialog)) = 
      GTK_RESPONSE_APPLY)
  then
    gtk_label_set_label (GTK_LABEL (szoveg),
                         '"Save" megnyomva.')
  else
    gtk_label_set_label (GTK_LABEL (szoveg),
                         'Nyomj a gombra!');
  gtk_widget_destroy (dialog);
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 5);
  szoveg := gtk_label_new ('Nyomj a gombra!');
  gomb := gtk_button_new_with_label ('gomb');

  gtk_widget_set_size_request (foablak, 200, 100);
  gtk_window_set_title (GTK_WINDOW (foablak), 'Foablak');
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), szoveg, false, true, 0);
  gtk_box_pack_end (GTK_BOX (vdoboz), gomb, false, false, 0);

  g_signal_connect (G_OBJECT (gomb), 'clicked',
                    G_CALLBACK (@dialog_mutat), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
