{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program draganddrop;
{$mode objfpc}{$H+}
{$apptype GUI}

uses
  gtk2, glib2, gdk2;

var
  foablak, gomb : PGtkWidget;

function elmozgat (widget:PGtkWidget;
                   event:PGdkEventButton) : gboolean; cdecl;
begin
  if event^._type = GDK_BUTTON_PRESS then
    if event^.button = 1 then
      gtk_window_begin_move_drag
          (GTK_WINDOW (gtk_widget_get_toplevel (widget)),
           event^.button,
           trunc (event^.x_root),
           trunc (event^.y_root),
           event^.time);
  elmozgat := false;
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gomb := gtk_button_new_from_stock (GTK_STOCK_QUIT);

  gtk_window_set_decorated (GTK_WINDOW (foablak), false);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 78);
  gtk_container_add (GTK_CONTAINER (foablak), gomb);

  gtk_widget_add_events (foablak, GDK_BUTTON_PRESS_MASK);

  g_signal_connect (G_OBJECT (foablak), 'button_press_event',
                    G_CALLBACK (@elmozgat), NULL);

  g_signal_connect_swapped (G_OBJECT (gomb), 'clicked',
                    G_CALLBACK (@gtk_widget_destroy),
                    G_OBJECT (foablak));

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
