{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program textview;
{$mode objfpc}{$H+}

uses
  gtk2, glib2, sysutils;

var
  foablak, vdoboz, gordito,
  gomb, szdoboz, statusz : PGtkWidget;
  puffer : PGtkTextBuffer;
  sor, kar : string;

procedure bevitel;
begin
  if gtk_text_view_get_editable
         (GTK_TEXT_VIEW (szdoboz)) then
  begin
    gtk_text_view_set_editable
        (GTK_TEXT_VIEW (szdoboz), false);
    gtk_text_view_set_cursor_visible
        (GTK_TEXT_VIEW (szdoboz), false);
    gtk_statusbar_push
        (GTK_STATUSBAR (statusz), 0,
        'Szovegbevitel letiltva');
    gtk_widget_grab_focus (szdoboz);
  end else
  begin
    gtk_text_view_set_editable
        (GTK_TEXT_VIEW (szdoboz), true);
    gtk_text_view_set_cursor_visible
        (GTK_TEXT_VIEW (szdoboz), true);
    gtk_statusbar_push
        (GTK_STATUSBAR (statusz), 0,
        'Szovegbevitel engedelyezve');
    gtk_widget_grab_focus (szdoboz);
  end;
end;

procedure allapot;
begin
  sor := inttostr
           (gtk_text_buffer_get_line_count (puffer));
  kar := inttostr
           (gtk_text_buffer_get_char_count (puffer));
  gtk_statusbar_push
      (GTK_STATUSBAR (statusz), 0, PGCHAR
      ('Ossz.: '+sor+' bekezdes | '+kar+' karakter'));
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 5);
  gomb := gtk_check_button_new_with_mnemonic
              ('_Szovegbevitel');
  gordito := gtk_scrolled_window_new (NULL, NULL);
  puffer := gtk_text_buffer_new (NULL);
  szdoboz := gtk_text_view_new_with_buffer (puffer);
  statusz := gtk_statusbar_new;

  gtk_widget_set_size_request (gordito, 400, 250);
  gtk_window_set_title (GTK_WINDOW (foablak), 'Szovegdoboz');
  gtk_scrolled_window_set_policy
      (GTK_SCROLLED_WINDOW (gordito), 1, 0);
  gtk_text_view_set_indent
     (GTK_TEXT_VIEW (szdoboz), 10);
  gtk_text_view_set_pixels_above_lines
      (GTK_TEXT_VIEW (szdoboz), 10);
  gtk_text_view_set_justification
      (GTK_TEXT_VIEW (szdoboz), GTK_JUSTIFY_FILL);
  gtk_text_view_set_wrap_mode
      (GTK_TEXT_VIEW (szdoboz), GTK_WRAP_WORD);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (gomb), true);
  gtk_statusbar_push (GTK_STATUSBAR (statusz), 0,
                      'Ossz.: 1 bekezdes | 0 karakter');

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), gomb, false, true, 0);
  gtk_box_pack_start (GTK_BOX (vdoboz), gordito, true, true, 0);
  gtk_box_pack_end (GTK_BOX (vdoboz), statusz, false, true, 0);
  gtk_container_add (GTK_CONTAINER (gordito), szdoboz);

  gtk_widget_grab_focus (szdoboz);

  g_signal_connect (G_OBJECT (gomb), 'toggled',
                    G_CALLBACK (@bevitel), NULL);

  g_signal_connect (G_OBJECT (puffer), 'end_user_action',
                    G_CALLBACK (@allapot), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
