{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program colorsel;
{$mode objfpc}{$H+}

uses
  gtk2, glib2, gdk2;

var
  foablak,
  vdoboz,
  szinter,
  gomb1, gomb2 : PGtkWidget;
  szin         : TGdkColor;

procedure szinval1;
begin
  gtk_color_button_get_color
      (GTK_COLOR_BUTTON (gomb1), @szin);
  gtk_widget_modify_bg (szinter, GTK_STATE_NORMAL, @szin);
end;

procedure szinval2;
var
  szvablak : PGtkWidget;
  szinval  : PGtkColorSelection;
begin
  szvablak := gtk_color_selection_dialog_new 
                  ('Szinvalasztas');
  szinval := GTK_COLOR_SELECTION
    (GTK_COLOR_SELECTION_DIALOG (szvablak)^.colorsel);
  gtk_color_selection_set_previous_color (szinval, @szin);
  gtk_color_selection_set_current_color (szinval, @szin);
  gtk_color_selection_set_has_palette (szinval, true);
  gtk_color_selection_set_has_opacity_control (szinval, true);
  if (gtk_dialog_run (GTK_DIALOG (szvablak)) =
      GTK_RESPONSE_OK) then
  begin
    gtk_color_selection_get_current_color (szinval, @szin);
    gtk_widget_modify_bg (szinter, GTK_STATE_NORMAL, @szin);
    gtk_color_button_set_color
        (GTK_COLOR_BUTTON (gomb1), @szin);
  end;
  gtk_widget_destroy (szvablak);
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (true, 10);

  szin.red   := $E0E0;  // #E0DFE3 szin beallitasa
  szin.green := $DFDF;
  szin.blue  := $E3E3;
  gomb1 := gtk_color_button_new_with_color (@szin);
  gomb2 := gtk_button_new_from_stock (GTK_STOCK_SELECT_COLOR);
  szinter := gtk_drawing_area_new;

  gtk_window_set_title (GTK_WINDOW (foablak), 'Szinvalasztas');
  gtk_widget_set_size_request (foablak, 300, 150);
  gtk_window_set_resizable (GTK_WINDOW (foablak), false);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);

  gtk_color_button_set_title
      (GTK_COLOR_BUTTON (gomb1), 'Szinvalasztas');
  gtk_color_button_set_use_alpha
      (GTK_COLOR_BUTTON (gomb1), true);
  gtk_color_button_set_alpha (GTK_COLOR_BUTTON (gomb1), 65535);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), szinter, true, true, 0);
  gtk_box_pack_start (GTK_BOX (vdoboz), gomb1, false, false, 0);
  gtk_box_pack_start (GTK_BOX (vdoboz), gomb2, false, false, 0);

  g_signal_connect (G_OBJECT (gomb1), 'color_set',
                    G_CALLBACK (@szinval1), NULL);
  g_signal_connect (G_OBJECT (gomb2), 'clicked',
                    G_CALLBACK (@szinval2), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
