{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program filechooser_ch;
{$mode objfpc}{$H+}

uses
  gtk2, glib2, sysutils;

var
  foablak,
  vdoboz,
  gomb,
  gordito, szdoboz : PGtkWidget;
  puffer : PGtkTextBuffer;

procedure megnyitas;
var
  f  : text;
  ch : char;
  s  : string;
begin
  try
    assign (f, gtk_file_chooser_get_filename
                   (GTK_FILE_CHOOSER (gomb)));
    reset (f);
    gtk_text_buffer_set_text (puffer, '', -1);
    while not (eof (f)) do
    begin
      s := '';
      while not (eof (f)) do
      begin
        read (f, ch);
        if ch <> #13 then s := s + ch;
        if ord (ch) < 127 then break;
      end;
      gtk_text_buffer_insert_at_cursor
          (puffer, Pgchar (s), -1);
    end;
  except
    on EInOutError do
    begin
      gtk_window_set_title
          (GTK_WINDOW (foablak), 'Fajlmegnyitasi hiba!');
      exit;
    end;
  end;
  close (f);
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 10);
  gordito := gtk_scrolled_window_new (NULL, NULL);
  puffer := gtk_text_buffer_new (NULL);
  szdoboz := gtk_text_view_new_with_buffer (puffer);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Megnyitas');
  gtk_widget_set_size_request (szdoboz, 400, 300);
  gtk_scrolled_window_set_policy
      (GTK_SCROLLED_WINDOW (gordito), 1, 0);

  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), gordito, true, true, 0);
  gtk_container_add (GTK_CONTAINER (gordito), szdoboz);

  gomb := gtk_file_chooser_button_new (NULL,
              GTK_FILE_CHOOSER_ACTION_OPEN);
  gtk_box_pack_start (GTK_BOX (vdoboz), gomb, false, true, 0);
  g_signal_connect (G_OBJECT (gomb), 'selection_changed',
                    G_CALLBACK (@megnyitas), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
