{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program fontsel;
{$mode objfpc}{$H+}

uses
  gtk2, glib2, pango;

var
  foablak,
  vdoboz,
  felirat,
  gomb1, gomb2 : PGtkWidget;
  betutipus    : TPangoFontDescription;

procedure betuval1;
begin
  betutipus := pango_font_description_from_string
                     (gtk_font_button_get_font_name
                          (GTK_FONT_BUTTON (gomb1)));
  gtk_widget_modify_font (felirat, betutipus);
end;

procedure betuval2;
var
  bvablak : PGtkWidget;
begin
  bvablak := gtk_font_selection_dialog_new ('Betuvalasztas');
  gtk_font_selection_dialog_set_font_name
      (GTK_FONT_SELECTION_DIALOG (bvablak),
       pango_font_description_to_string (betutipus));
  if (gtk_dialog_run (GTK_DIALOG (bvablak)) =
      GTK_RESPONSE_OK) then
  begin
    betutipus := pango_font_description_from_string
                       (gtk_font_selection_dialog_get_font_name
                            (GTK_FONT_SELECTION_DIALOG (bvablak)));
    gtk_widget_modify_font (felirat, betutipus);
    gtk_font_button_set_font_name (GTK_FONT_BUTTON (gomb1),
        pango_font_description_to_string (betutipus));
  end;
  gtk_widget_destroy (bvablak);
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (true, 10);

  felirat := gtk_label_new ('Ez itt egy felirat');
  betutipus := pango_font_description_from_string
                     ('Lucida Console 10');
  gtk_widget_modify_font (felirat, betutipus);

  gomb1 := gtk_font_button_new_with_font
               ('Lucida Console 10');;
  gtk_font_button_set_use_font (GTK_FONT_BUTTON (gomb1), true);
  gomb2 := gtk_button_new_from_stock (GTK_STOCK_SELECT_FONT);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Betuvalasztas');
  gtk_widget_set_size_request (foablak, 300, 150);
  gtk_window_set_resizable (GTK_WINDOW (foablak), false);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);

  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), felirat, true, true, 0);
  gtk_box_pack_start (GTK_BOX (vdoboz), gomb1, false, false, 0);
  gtk_box_pack_start (GTK_BOX (vdoboz), gomb2, false, false, 0);

  g_signal_connect (G_OBJECT (gomb1), 'font_set',
                    G_CALLBACK (@betuval1), NULL);
  g_signal_connect (G_OBJECT (gomb2), 'clicked',
                    G_CALLBACK (@betuval2), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
