{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program pixbufsave;
{$mode objfpc}{$H+}

uses
  gtk2, glib2, gdk2pixbuf;

var
  foablak, vdoboz, gomb,
  ikon : PGtkWidget;
  pixbuf : PGdkPixbuf;
  hiba : PGError = NULL;

procedure valtoztat;
begin
  gdk_pixbuf_saturate_and_pixelate (pixbuf,
      pixbuf, 1.1, false);
  gtk_widget_hide (ikon);
  gtk_widget_show (ikon);
end;

procedure mentes;
begin
  gdk_pixbuf_save (pixbuf, 'ujfajl.png', 'png', @hiba,
                   [NULL]);
  gdk_pixbuf_save (pixbuf, 'ujfajl.ico', 'ico', @hiba,
                   [NULL]);
  if gdk_pixbuf_get_has_alpha (pixbuf) = true then
    writeln ('A kep atlaszosagot tartalmaz!') else
  begin
    gdk_pixbuf_save (pixbuf, 'ujfajl.jpg', 'jpg', @hiba,
                     ['quality', '97', NULL]);
    gdk_pixbuf_save (pixbuf, 'ujfajl.bmp', 'bmp', @hiba,
                     [NULL]);
  end;
end;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  vdoboz := gtk_vbox_new (false, 5);

  pixbuf := gdk_pixbuf_new_from_file
                ('gart-home.png', @hiba);
  ikon := gtk_image_new_from_pixbuf (pixbuf);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Pixel puffer');
  gtk_window_set_default_size (GTK_WINDOW (foablak), 200, -1);

  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);
  gtk_container_add (GTK_CONTAINER (foablak), vdoboz);
  gtk_box_pack_start (GTK_BOX (vdoboz), ikon, false, false, 0);

  gomb := gtk_button_new_with_label ('elment');
  gtk_box_pack_end (GTK_BOX (vdoboz), gomb, false, false, 0);
  g_signal_connect (G_OBJECT (gomb), 'clicked',
                    G_CALLBACK (@mentes), NULL);

  gomb := gtk_button_new_with_label ('valtoztat');
  gtk_box_pack_end (GTK_BOX (vdoboz), gomb, false, false, 0);
  g_signal_connect (G_OBJECT (gomb), 'clicked',
                    G_CALLBACK (@valtoztat), NULL);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
