{-------------------------------------------------------------}
{ Peldaprogram a GTK+ programozas Free Pascalban c. konyvhoz  }
{-------------------------------------------------------------}

program style;
{$mode objfpc}{$H+}

uses
  gtk2, glib2, gdk2;

var
  foablak, gomb : PGtkWidget;
  stilus : PGtkStyle;
  pixmap : PGdkPixmap;
  cmap   : PGdkColormap; 
  mask   : PGdkBitmap;

begin

  gtk_init (@argc, @argv);

  foablak := gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gomb := gtk_button_new_with_label ('Szines gomb');
  stilus := gtk_widget_get_style (gomb);

  gtk_window_set_title (GTK_WINDOW (foablak), 'Stilusok');
  gtk_window_set_default_size (GTK_WINDOW (foablak), 200, 80);
  gtk_container_set_border_width (GTK_CONTAINER (foablak), 10);

  with stilus^.bg [GTK_STATE_NORMAL] do
  begin
    red := $5e00;
    green := $9600;
    blue := $db00;
  end;

  with stilus^.bg [GTK_STATE_ACTIVE] do
  begin
    red := $2600;
    green := $6600;
    blue := $b500;
  end;

  cmap := gdk_colormap_get_system;
  pixmap := gdk_pixmap_colormap_create_from_xpm
                (foablak^.window,
                 cmap, mask, 
                 @stilus^.bg[GTK_STATE_NORMAL],
                 'gtk.xpm');
  stilus^.bg_pixmap [GTK_STATE_PRELIGHT] := pixmap;
 
  gtk_widget_set_style (gomb, stilus);

  gtk_container_add (GTK_CONTAINER (foablak), gomb);

  g_signal_connect (G_OBJECT (foablak), 'destroy',
                    G_CALLBACK (@gtk_main_quit), NULL);

  gtk_widget_show_all (foablak);
  gtk_main;

end.
